#property link      "toro.corpo"
#define buy -2
#define sell 2
//---- input parameters
extern string  separator_01=" Initial Settings";
extern bool      use_daily_target=false;
extern double    daily_target=100;
extern bool      trade_in_fri=true;
extern int       magic=1;
extern double    start_lot=0.02;
extern double    range=25;
extern int       level=10;
extern bool      lot_multiplier=true;
extern double    multiplier=2.0;
extern double    increament=0.1;
extern double    tp_in_money=10;
extern bool      stealth_mode=true;
extern string  separator_02=" Use TP and SL";
extern bool      use_sl_and_tp=false;
extern double    sl=60;
extern double    tp=30;
extern string  separator_03=" Signal Settings";
extern bool      use_bb=true;
extern int       bb_period=20;
extern int       bb_deviation=2;
extern int       bb_shift=0;
extern bool      use_stoch=false;
extern int       k=5;
extern int       d=3;
extern int       slowing=3;
extern int       price_field=0;
extern int       stoch_shift=0;
extern int       lo_level=30;
extern int       up_level=70;
extern bool      use_rsi=false;
extern int       rsi_period=12;
extern int       rsi_shift=0;
extern int       lower=30;
extern int       upper=70;
extern bool      use_macd=false;
extern int       Time_Frame=0;
extern int       EMA_Period=14;
extern int       Low_EMA_Period=26;
extern int       Signal_Period=9;
extern string  separator_04=" Time Limit settings";
extern bool      use_time_limit=false;
extern double    begin_time_GMT=8;
extern double    stop_time_GMT=17; 

extern string  separator_06=" Fully hedge setting";
extern bool      fully_hedge=true;
extern string  separator_07=" Partially hedge setting";
extern bool      partial_hedge=true;
extern int       partial_hedge_level=1;
extern string  separator_08=" Equity check setting";
extern bool      equity_check=false;
extern double    close_at_equity_equal=1000;

extern string  separator_05=" Dynamic Range setting";
extern bool      dynamic_range=false;
extern double    range1=8;
extern double    range2=8;
extern double    range3=15;
extern double    range4=15;
extern double    range5=15;
extern double    range6=15;
extern double    range7=15;
extern double    range8=15;
extern double    range9=15;
extern double    range10=15;
extern double    range_default=10;

extern string  separator_09=" Dynamic Profit setting";
extern double    profit1=15;
extern double    profit2=15;
extern double    profit3=20;
extern double    profit4=30;
extern double    profit5=40;
extern double    profit6=50;
extern double    profit7=60;
extern double    profit8=100;
extern double    profit9=100;
extern double    profit10=200;
extern double    profit_default=15;


double pt;
double minlot;
double stoplevel;
int prec=0;
int a=0;
int ticket=0; 
int type_initial;
bool check_close_all;
bool check_hedge_order;
double temp_lot;

// more function 1. Hedge when reach Level -- done
//               2. Time limit (open trade in specific period of time)--done
//               3. Next order was placed at the range*total() -- done -- removed 01 Jeb.
//               4. Take more profit -- done -- removed 01 Feb.
//               5. Hedge partially -- done
//               6. Check to close all at specifit equity -- done
//               7. Dynamic range as in put -- done -- added 01 Feb.
//               8. Dynamic tp_in_money as input -- done -- added 01 Feb.
//               9. Modify the Time limit (with begin time and stop time)
//              10. check_close_all added
//              11. Modify the partial hedge order function -- done -- 04 Feb. and 17 Feb
//              12. reverse signal on 3 indicators -- done -- 17 Feb.
//              13. clean code --> only use multiplier, not use tp_and_sl, lot_increament anymore


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   if(Digits==3 || Digits==5) pt=10*Point;
   else                          pt=Point;
   minlot   =   MarketInfo(Symbol(),MODE_MINLOT);
   stoplevel=MarketInfo(Symbol(),MODE_STOPLEVEL);
   if(start_lot<minlot)      Print("lotsize is to small.");
   if(sl<stoplevel)   Print("stoploss is to tight.");
   if(tp<stoplevel) Print("takeprofit is to tight.");
   if(minlot==0.01) prec=2;
   if(minlot==0.1)  prec=1;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
    //-------------------------------Check trading time
    
   if (use_time_limit && (begin_time_GMT<stop_time_GMT) && ((Hour()<begin_time_GMT) || (Hour()> stop_time_GMT)) && (total()==0) )
   {
      Comment("\nNo trading because of Time Limit!");
      return(0);   
   }
    
     if (use_time_limit && (begin_time_GMT>stop_time_GMT) && (Hour()<begin_time_GMT) && (Hour()> stop_time_GMT) && (total()==0) )
   {
      Comment("\nNo trading because of Time Limit!");
      return(0);   
   }
  
if(use_daily_target && dailyprofit()>=daily_target)
{
Comment("\ndaily target achieved.");
return(0);
}
   
   if(!trade_in_fri && DayOfWeek()==5 && total()==0)
   {
     Comment("\nstop trading in Friday.");
     return(0);
   }
    
  //---------- Close all with Equity check
   if (equity_check && AccountEquity()<=close_at_equity_equal) {closeall(); return(0); Comment("\nHit Equity check");}
   
   //---------------Check_close_all-------------------
   if (total()==0) {check_close_all=false;}
   //--------------------------------- Place first Order
   if(total()==0 && a==0)
   {
     if(signal()==buy && check_close_all==false)
     {
        if(stealth_mode)
        {
   if(use_sl_and_tp) ticket=OrderSend(Symbol(),0,start_lot,Ask,3,Ask-sl*pt,Ask+tp*pt,"",magic,0,Blue);
   else              
          ticket=OrderSend(Symbol(),0,start_lot,Ask,3,        0,        0,"",magic,0,Blue);

   else
   {
   if(use_sl_and_tp) 

             if(OrderSend(Symbol(),0,start_lot,Ask,3,Ask-sl*pt,Ask+tp*pt,"",magic,0,Blue)>0)
             {
                for(int i=1; i<level; i++)
                {
                    if(lot_multiplier) ticket=OrderSend(Symbol(),2,NormalizeDouble(start_lot*MathPow(multiplier,i),prec),Ask-(range*i)*pt,3,(Ask-(range*i)*pt)-sl*pt,(Ask-(range*i)*pt)+tp*pt,"",magic,0,Blue);
                    else               ticket=OrderSend(Symbol(),2,NormalizeDouble(start_lot+increament*i,prec)         ,Ask-(range*i)*pt,3,(Ask-(range*i)*pt)-sl*pt,(Ask-(range*i)*pt)+tp*pt,"",magic,0,Blue);
                }
             }
          }
          else
          {
             if(OrderSend(Symbol(),0,start_lot,Ask,3,0,0,"",magic,0,Blue)>0)
             {
                for(i=1; i<level; i++)
                {
                    if(lot_multiplier) ticket=OrderSend(Symbol(),2,NormalizeDouble(start_lot*MathPow(multiplier,i),prec),Ask-(range*i)*pt,3,0,0,"",magic,0,Blue);
                    else               ticket=OrderSend(Symbol(),2,NormalizeDouble(start_lot+increament*i,prec)         ,Ask-(range*i)*pt,3,0,0,"",magic,0,Blue);
                }
             }
          }
*/        }
     }
     if(signal()==sell && check_close_all==false)
     {
        if(stealth_mode)
        {
if(use_sl_and_tp) ticket=OrderSend(Symbol(),1,start_lot,Bid,3,Bid+sl*pt,Bid-tp*pt,"",magic,0,Red);
else              
          ticket=OrderSend(Symbol(),1,start_lot,Bid,3,        0,        0,"",magic,0,Red);
          
        else
        {
          if(use_sl_and_tp) 
          {
             if(OrderSend(Symbol(),1,start_lot,Bid,3,Bid+sl*pt,Bid-tp*pt,"",magic,0,Red)>0)
             {
                for(i=1; i<level; i++)
                {
                    if(lot_multiplier) ticket=OrderSend(Symbol(),3,NormalizeDouble(start_lot*MathPow(multiplier,i),prec),Bid+(range*i)*pt,3,(Bid+(range*i)*pt)+sl*pt,(Bid+(range*i)*pt)-tp*pt,"",magic,0,Red);
                    else               ticket=OrderSend(Symbol(),3,NormalizeDouble(start_lot+increament*i,prec)         ,Bid+(range*i)*pt,3,(Bid+(range*i)*pt)+sl*pt,(Bid+(range*i)*pt)-tp*pt,"",magic,0,Red);
                }
             }
          }
          else
          {
             if(OrderSend(Symbol(),1,start_lot,Bid,3,0,0,"",magic,0,Red)>0)
             {
                for(i=1; i<level; i++)
                {
                    if(lot_multiplier) ticket=OrderSend(Symbol(),3,NormalizeDouble(start_lot*MathPow(multiplier,i),prec),Bid+(range*i)*pt,3,0,0,"",magic,0,Red);
                    else               ticket=OrderSend(Symbol(),3,NormalizeDouble(start_lot+increament*i,prec)         ,Bid+(range*i)*pt,3,0,0,"",magic,0,Red);
                }
             }
          }
        }
*/     } 
   }
   }
   
   //-----------------------------Place next Order
   if(stealth_mode && total()>0 && total()<level)
   {
     int type, order_count=0; double op, lastlot; 
      
     for(int i=0; i<OrdersTotal(); i++)
     {
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=magic) continue;
         order_count++;
         if(order_count==1) {type_initial=OrderType();}          
         if (OrderType()==type_initial)
           {
           op=OrderOpenPrice();
           lastlot=OrderLots();
           } 
         
     }
       
       
     switch(total())
         { 
         case 1 : range=range1; break;
         case 2 : range=range2; break;
         case 3 : range=range3; break;
         case 4 : range=range4; break;
         case 5 : range=range5; break;
         case 6 : range=range6; break;
         case 7 : range=range7; break;
         case 8 : range=range8; break;
         case 9 : range=range9; break;
         case 10 : range=range10; break;
         default : range=range_default; break;
         }
        
       
     if(type_initial==0 && Ask<=op-range*pt && check_close_all==false) 
     {
if(use_sl_and_tp)
 {
if(lot_multiplier) 
ticket=OrderSend(Symbol(),0,NormalizeDouble(lastlot*multiplier,prec),Ask,3,Ask-sl*pt,Ask+tp*pt,"",magic,0,Blue);
  else               ticket=OrderSend(Symbol(),0,NormalizeDouble(lastlot+increament,prec),Ask,3,Ask-sl*pt,Ask+tp*pt,"",magic,0,Blue);
 }
  else
 {
 if(lot_multiplier) 
 check_hedge_order=false;
          temp_lot=lastlot;
          ticket=OrderSend(Symbol(),0,NormalizeDouble(lastlot*multiplier,prec),Ask,3,0,0,"",magic,0,Blue);


    else               ticket=OrderSend(Symbol(),0,NormalizeDouble(lastlot+increament,prec),Ask,3,0,0,"",magic,0,Blue);
     }
    /
   if (partial_hedge && order_count>=partial_hedge_level)  // place partial hegde orders 
  {
    ticket=OrderSend(Symbol(),1,lastlot,Bid,3,0,Bid-range*pt,"",magic,0,Red);           
  } 
     }
     
     if(type_initial==1 && Bid>=op+range*pt && check_close_all==false) 
     {
 if(use_sl_and_tp)
    {
if(lot_multiplier) ticket=OrderSend(Symbol(),1,NormalizeDouble(lastlot*multiplier,prec),Bid,3,Bid+sl*pt,Bid-tp*pt,"",magic,0,Red);
  else               ticket=OrderSend(Symbol(),1,NormalizeDouble(lastlot+increament,prec),Bid,3,Bid+sl*pt,Bid-tp*pt,"",magic,0,Red);
  }
 else
     {
   if(lot_multiplier) 
      check_hedge_order=false;
          temp_lot=lastlot;
          ticket=OrderSend(Symbol(),1,NormalizeDouble(lastlot*multiplier,prec),Bid,3,0,0,"",magic,0,Red);

  else               ticket=OrderSend(Symbol(),1,NormalizeDouble(lastlot+increament,prec),Bid,3,0,0,"",magic,0,Red);
    }
        
if (partial_hedge && order_count>=partial_hedge_level)  // place partial hegde orders 
      {
  ticket=OrderSend(Symbol(),0,lastlot,Ask,3,0,Ask+range*pt,"",magic,0,Blue);
   }

     }
   
   
     //-------------------- Place partially hedge orders
/*     if(partial_hedge)
       { 
         if(type_initial==0 && Ask<=op-range*pt && order_count>=partial_hedge_level && check_close_all==false) 
         {
           ticket=OrderSend(Symbol(),1,lastlot,Bid,3,0,Bid-range*pt,"",magic,0,Red);           
         }
     
         if(type_initial==1 && Bid>=op+range*pt && order_count>=partial_hedge_level && check_close_all==false) 
         {
           ticket=OrderSend(Symbol(),0,lastlot,Ask,3,0,Ask+range*pt,"",magic,0,Blue);
         }
       }
   
*/   
   }
   
if (check_hedge_order==false)
{
     int count1=0, count2=0;
     
     for(i=0; i<OrdersTotal(); i++)
     {
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=magic) continue;
         if(OrderType()==type_initial) count1++;
         else count2++;
               
     }
     
     if ((count1>1) && (count2<1) && (check_close_all==false))
     {
       if(type_initial==0)
       {
         ticket=OrderSend(Symbol(),1,temp_lot,Bid,3,0,Bid-range*pt,"",magic,0,Red);           
       }    
     
       if(type_initial==1)
       {
         ticket=OrderSend(Symbol(),0,temp_lot,Ask,3,0,Ask+range*pt,"",magic,0,Blue);
       }
 check_hedge_order=true;
     }   
  }
   
   
   
        //-------------------- Place fully hedge order
   if(stealth_mode && total()==level && fully_hedge)
   {
     
     double op2; int order_count_hedge=0; 
   
     for(i=0; i<OrdersTotal(); i++)
     {
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=magic) continue;
         order_count_hedge++;
         if(order_count_hedge==1) {type_initial=OrderType();}          
         op2=OrderOpenPrice();
     }
       
     
     if(type_initial==0 && Ask<=op2-range*pt) 
     {
        ticket=OrderSend(Symbol(),1,totallot(),Bid,3,0,0,"",magic,0,Red);           
     }
     
     if(type_initial==1 && Bid>=op2+range*pt) 
     {
        ticket=OrderSend(Symbol(),0,totallot(),Ask,3,0,0,"",magic,0,Blue);
     }
     Comment("\nHedge order placed.");
     return(0);
   }
   
//--------Use Stop lose and Take profit
   if(use_sl_and_tp && total()>1)
   {
     double s_l, t_p;
     for(i=0; i<OrdersTotal(); i++)
     {
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=magic || OrderType()>1) continue;
         type=OrderType();
         s_l=OrderStopLoss();
         t_p=OrderTakeProfit();
     }
     for(i=OrdersTotal()-1; i>=0; i--)
     {
       OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
       if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=magic || OrderType()>1) continue;
       if(OrderType()==type)
       {
          if(OrderStopLoss()!=s_l || OrderTakeProfit()!=t_p)
          {
             OrderModify(OrderTicket(),OrderOpenPrice(),s_l,t_p,0,CLR_NONE);
          }
       }
     }
   }
*/   
//---------- Take profit function------------------
   double profit=0;
   for(i=0; i<OrdersTotal(); i++)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=magic || OrderType()>1) continue;
      profit+=OrderProfit();
   }
   
     switch(total())
         { 
         case 1 : tp_in_money=profit1; break;
         case 2 : tp_in_money=profit2; break;
         case 3 : tp_in_money=profit3; break;
         case 4 : tp_in_money=profit4; break;
         case 5 : tp_in_money=profit5; break;
         case 6 : tp_in_money=profit6; break;
         case 7 : tp_in_money=profit7; break;
         case 8 : tp_in_money=profit8; break;
         case 9 : tp_in_money=profit9; break;
         case 10 : tp_in_money=profit10; break;
         default : range=range_default; break;
         }

   if(profit>=tp_in_money || a>0) 
   {
      closeall();
      closeall();
      closeall();
      a++;
      if(total()==0) a=0;
   }
  
   
  
 if(!stealth_mode && use_sl_and_tp && total()<level) closeall();
----
   
----
   return(0);
  }
  
+------------------------------------------------------------------+
*double dailyprofit()
{
  int day=Day(); double res=0;
  for(int i=0; i<OrdersHistoryTotal(); i++)
  {
      OrderSelect(i,SELECT_BY_POS,MODE_HISTORY);
      if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=magic) continue;
      if(TimeDay(OrderOpenTime())==day) res+=OrderProfit();
  }
  return(res);
}
*/
+------------------------------------------------------------------+
int total()
{
  int total=0, order_count_total=0;
  for(int i=0; i<OrdersTotal(); i++)
  {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=magic) continue;
      order_count_total++; 
      if (order_count_total==1) {type_initial=OrderType();}
      if (OrderType()==type_initial) {total++;}
  }
  return(total);
}
+------------------------------------------------------------------+
int signal()
{
  double upBB=iBands(Symbol(),0,bb_period,bb_deviation,0,PRICE_CLOSE,MODE_UPPER,bb_shift);
  double loBB=iBands(Symbol(),0,bb_period,bb_deviation,0,PRICE_CLOSE,MODE_LOWER,bb_shift);
  double lowMACD     =iMACD(Symbol(),Time_Frame,EMA_Period,Low_EMA_Period,Signal_Period,PRICE_CLOSE,MODE_MAIN,0);
  double highMACD    =iMACD(Symbol(),Time_Frame,EMA_Period,Low_EMA_Period,Signal_Period,PRICE_CLOSE,MODE_MAIN,1);
  double stoch=iStochastic(Symbol(),0,k,d,slowing,MODE_SMA,price_field,MODE_SIGNAL,stoch_shift);
  double rsi=iRSI(Symbol(),0,rsi_period,PRICE_CLOSE,rsi_shift);
  if(!use_bb && !use_stoch && !use_rsi && use_macd)
  {
      if(lowMACD>highMACD) return(sell);
      if(lowMACD<highMACD) return(buy);
  }
  if(use_bb && use_stoch && use_rsi)
  {
     if(High[bb_shift]>upBB && stoch>up_level && rsi>upper) return(buy);
     if(Low[bb_shift]<loBB && stoch<lo_level && rsi<lower)   return(sell);
  }
  if(use_bb && !use_stoch && !use_rsi)
  {
     if(High[0]>upBB) return(sell);  // use Ask instead of High[0]
     if(Low[0]<loBB)   return(buy); // use Bid instead of Low[0]
  }

*  if(use_bb && use_stoch && !use_rsi)
  {
     if(High[bb_shift]>upBB && stoch>up_level) return(sell);
     if(Low[bb_shift]<loBB && stoch<lo_level)   return(buy);
  }
  if(!use_bb && use_stoch && use_rsi)
  {
     if(stoch>up_level && rsi>upper) return(sell);
     if(stoch<lo_level && rsi<lower)   return(buy);
  }
  if(!use_bb && use_stoch && !use_rsi)
  {
     if(stoch>up_level) return(sell);
     if(stoch<lo_level)  return(buy);
  }
  if(use_bb && !use_stoch && use_rsi)
  {
     if(High[bb_shift]>upBB && rsi>upper) return(sell);
     if(Low[bb_shift]<loBB && rsi<lower)   return(buy);
  }
  if(!use_bb && !use_stoch && use_rsi)
  {
     if(rsi>upper) return(sell);
     if(rsi<lower)  return(buy);
  }
*/  
  return(0);
}

+------------------------------------------------------------------+
void closeall()
{
  for(int i=OrdersTotal()-1; i>=0; i--)
  {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=magic) continue;
      check_close_all=true; 
      if(OrderType()>1) OrderDelete(OrderTicket());
      else
      {
        if(OrderType()==0) OrderClose(OrderTicket(),OrderLots(),Bid,3,CLR_NONE);
        else               OrderClose(OrderTicket(),OrderLots(),Ask,3,CLR_NONE);
      }
  }
}
//-----------------------Count total lot function------------------------------
double totallot()
{
  double totallot=0; int order_count_totallot=0;
  
  for(int i=0; i<OrdersTotal(); i++)
     {
         OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()!=Symbol() || OrderMagicNumber()!=magic) continue;
         order_count_totallot++; 
         if (order_count_totallot==1) {type_initial=OrderType();}
         if (OrderType()==type_initial) {totallot+=OrderLots();}
     }
  return(totallot);
}

